#include "gpnd.h"


int gpndArgIsPath(const char *str) {
	if (strstr(str, "/") != NULL)
		return 1;
	if (strstr(str, "..") != NULL)
		return 1;
	if (strstr(str, "~") != NULL)
		return 1;
	return 0;
}


int gpndPathIsRelative(const char *str) {
	if (str[0] == '/')
		return 0;
	return 1;
}


void gpndLoadLocales(GPND_MAIN *m) {
	FILE *fp;
	int i;
	char buff[20];

	m->locales = NULL;
	
	if ((fp = fopen("locales", "r")) == NULL) {
		guiShowErrorMessage(m, "Failed to open locales file! Make sure it is in the same directory as this application and try again.");
		exit(254);
	}

	for (i = 0; !feof(fp); i++) {
		if ((m->locales = realloc(m->locales, sizeof(char *) * (i + 1))) == NULL) {
			fclose(fp);
			guiShowErrorMessage(m, "Out of RAM!");
			exit(2);
		}
		
		fgets(buff, 20, fp);
		m->locales[i] = malloc(strlen(buff));
		buff[strlen(buff) - 1] = '\0';

		sprintf(m->locales[i], "%s", buff);
	}

	fclose(fp);
	m->localelen = i;

	return;
}



int gpndFileExists(const char *path) {
	FILE *fp = NULL;

	if ((fp = fopen(path, "r")) == NULL) 
		return 0;

	fclose(fp);
	return 1;
}


void gpndEscapeXMLData(char *str) {
	int i;

	for (i = 0; str[i] != 0; i++) {
		if (str[i] == '"')
			str[i] = '\'';
		else if (str[i] == '<')
			str[i] = '[';
		else if (str[i] == '>')
			str[i] = ']';
	}

	return;
}


void gpndInitApp(GPND_MAIN *m) {
	m->app = malloc(sizeof(GPND_APP));
	m->app->flags = 0;

	return;
}


void gpndInitCat(GPND_MAIN *m, int app) {
	m->app[app].cat = malloc(sizeof(GPND_CATEGORY_STRUCT));
	m->app[app].cat->flags = 0;
	m->app[app].cat->cat = 0;
	m->app[app].cat->subcat = NULL;
	m->app[app].noofCat = 0;

	return;
}


void gpndInitMain(GPND_MAIN *m) {
	m->activeApp = -1;
	m->flags = 0;
	m->dirname = NULL;
	m->noofApps = 0;

	return;
}	


int main(int argc, char **argv) {
	GPND_MAIN m;

	gpndInitMain(&m);
	gpndInitApp(&m);
	guiInit(&m, &argc, &argv);
	guiMakeMainWindow(&m);
	gpndLoadLocales(&m);
	guiUpdateMainButtonActivity(&m);

	gtk_main();

	return 0;
}
