#include "gpnd.h"


int guiInit(GPND_MAIN *m, int *argc, char ***argv) {
	gtk_init(argc, argv);
	m->gui.state.flags &= (0xFFFFFFFF ^ GPND_GUI_CHILD_IS_OPEN);

	return 0;
}


void guiDisableAllMainButtons(GPND_MAIN *m) {
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.addApp), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.modApp), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.delApp), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appName), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appinfo), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.apprun), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.cat), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appndesc), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.applist), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.seldir), 0);
	gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.savepnd), 0);

	return;
}


void guiUpdateMainButtonActivity(GPND_MAIN *m) {
	guiDisableAllMainButtons(m);
	
	if (!(m->gui.state.flags & GPND_GUI_CHILD_IS_OPEN)) {
		if (m->flags & GPND_MAIN_DIR_IS_SET) {
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.addApp), 1);
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.modApp), 1);
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.delApp), 1);
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appName), 1);
		}

		if (m->noofApps > 0) {
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.applist), 1);
		}
			
		
		if (m->activeApp > -1) {
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appinfo), 1);
			
			if (m->app[m->activeApp].flags & GPND_GUI_GENERAL_INFO_IS_SET) {
				gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.apprun), 1);
				if (m->app[m->activeApp].flags & GPND_GUI_RUNTIME_INFO_IS_SET) {
					gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.appndesc), 1);
					if (m->app[m->activeApp].flags & GPND_GUI_NDESC_INFO_IS_SET) {
						gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.cat), 1);
					}
				}
			}
		} if (m->noofApps == 0) {
			gtk_widget_set_sensitive(GTK_WIDGET(m->gui.main.seldir), 1);
		}
	}
	
	return;
}


void guiAddToListView(GPND_MAIN *m, GtkWidget *list, const gchar *str) {
	GtkListStore *store;
	GtkTreeIter iter;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));

	gtk_list_store_append(store, &iter);
	gtk_list_store_set(store, &iter, 0, str, -1);

	return;
}


void guiInitListView(GPND_MAIN *m, GtkWidget *list) {
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkListStore *store;

	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes("List Items", renderer, "text", 0, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(list), column);

	store = gtk_list_store_new(1, G_TYPE_STRING);

	gtk_tree_view_set_model(GTK_TREE_VIEW(list), GTK_TREE_MODEL(store));

	g_object_unref(store);

	return;
}


void guiAddApp(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	const char *app;

	app = gtk_entry_get_text((GtkEntry *) m->gui.main.appName);
	if (appAdd(m, app) == -1)
		return;

	guiAddToListView(m, m->gui.main.applist, app);

	return;
}	


void guiModApp(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;
	const gchar *appname, *app;
	int id;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.main.applist));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.main.applist)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.main.applist));

	appname = gtk_entry_get_text((GtkEntry *) m->gui.main.appName);

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_tree_model_get(model, &iter, 0, &app,  -1);
		id = appGetID(m, app);
		
		if (appMod(m, appname, id) == -1)
			return;
		
		gtk_list_store_set(store, &iter, 0, appname, -1);
	}

	return;
}


void guiDelApp(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.main.applist));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.main.applist)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.main.applist));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		if (appDel(m) != -1) {
			gtk_entry_set_text((GtkEntry *) m->gui.main.appName, "");
			gtk_list_store_remove(store, &iter);
		}
	}

	return;
}


void guiChangeAppList(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;
	char *app;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.main.applist));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.main.applist)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.main.applist));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_tree_model_get(model, &iter, 0, &app,  -1);
		m->activeApp = appGetID(m, app);
		gtk_entry_set_text((GtkEntry *) m->gui.main.appName, m->app[m->activeApp].appname);

		guiUpdateMainButtonActivity(m);
	}

	return;
}


void guiAddLocale(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GPND_LOCALE_VALIDATE_INPUT_STRUCT val;
	gchar *desc;
	GtkTextIter start, end;
	GtkTextBuffer *buffer;

	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (m->gui.ndesc.desce));
	
	gtk_text_buffer_get_start_iter(buffer, &start);
	gtk_text_buffer_get_end_iter(buffer, &end);
	desc = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);

	val.locale = gtk_entry_get_text((GtkEntry *) m->gui.ndesc.lange);
	val.name = gtk_entry_get_text((GtkEntry *) m->gui.ndesc.namee);
	val.desc = (const char *) desc;
	
	if (localeValidate(m, &val) == -1) {
		g_free(desc);
		return;
	}

	if (localeAdd(m, &val) == -1) {
		g_free(desc);
		return;
	}

	if (strcmp(val.locale, "en_US") == 0) {
		m->app[m->activeApp].flags |= GPND_GUI_NDESC_INFO_IS_SET;
	}

	guiAddToListView(m, m->gui.ndesc.list, val.locale);
	g_free(desc);

	return;
}


void guiModLocale(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	char *curloc;
	GPND_LOCALE_VALIDATE_INPUT_STRUCT val;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter iter;
	gchar *desc;
	GtkTextIter start, end;
	GtkTextBuffer *buffer;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.ndesc.list));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.ndesc.list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.ndesc.list));
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (m->gui.ndesc.desce));
	
	gtk_text_buffer_get_start_iter(buffer, &start);
	gtk_text_buffer_get_end_iter(buffer, &end);
	desc = gtk_text_buffer_get_text(buffer, &start, &end, FALSE);

	val.locale = gtk_entry_get_text((GtkEntry *) m->gui.ndesc.lange);
	val.name = gtk_entry_get_text((GtkEntry *) m->gui.ndesc.namee);
	val.desc = (const char *) desc;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_tree_model_get(model, &iter, 0, &curloc,  -1);

		if (localeMod(m, curloc, &val) == -1) {
			g_free(desc);
			g_free(curloc);
			return;
		}
		gtk_list_store_set(store, &iter, 0, val.locale, -1);
	}

	if (localeExists(m, "en_US") == -1) {
		m->app[m->activeApp].flags |= GPND_GUI_NDESC_INFO_IS_SET;
		m->app[m->activeApp].flags ^= GPND_GUI_NDESC_INFO_IS_SET;
	}

	if (localeExists(m, "en_US") != -1) {
		m->app[m->activeApp].flags |= GPND_GUI_NDESC_INFO_IS_SET;
	}
	
	g_free(desc);
	g_free(curloc);

	return;
}


/*void guiDelLocale(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	char *curloc;
	GPND_LOCALE_VALIDATE_INPUT_STRUCT val;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter iter;
	gchar *desc;
	GtkTextIter start, end;
	GtkTextBuffer *buffer;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.ndesc.list));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.ndesc.list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.ndesc.list));
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (m->gui.ndesc.desce));


	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		/*gtk_tree_model_get(model, &iter, 0, &curloc,  -1);

		if (localeDel(m, curloc) == -1) {
			g_free(curloc);
			return;
		}
		
		g_free(curloc);*/
//		gtk_list_store_set(store, &iter, 0, "", -1);
//		gtk_list_store_remove(store, &iter);
		/*gtk_entry_set_text((GtkEntry *) m->gui.ndesc.lange, "");
		gtk_entry_set_text((GtkEntry *) m->gui.ndesc.namee, "");
		gtk_text_buffer_set_text(buffer, "", -1);*/
/*	}

	if (localeExists(m, "en_US") == -1) {
		m->app[m->activeApp].flags |= GPND_GUI_NDESC_INFO_IS_SET;
		m->app[m->activeApp].flags ^= GPND_GUI_NDESC_INFO_IS_SET;
	}

	return;
}
*/


void guiDelLocale(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.ndesc.list));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.ndesc.list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.ndesc.list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_list_store_remove(store, &iter);
	}

	return;
}


void guiUpdateLocale(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	char *curloc;
	int i;
	GtkTreeSelection *selection;
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter iter;
	GtkTextBuffer *buffer;

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.ndesc.list));
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (m->gui.ndesc.list)));
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(m->gui.ndesc.list));
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW (m->gui.ndesc.desce));
	
	
	
	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter)) {
		gtk_tree_model_get(model, &iter, 0, &curloc,  -1);

		if ((i = localeExists(m, curloc)) == -1) {
			g_free(curloc);
			return;
		}
		
		gtk_entry_set_text((GtkEntry *) m->gui.ndesc.lange, m->app[m->activeApp].ndesc[i].lang);
		gtk_entry_set_text((GtkEntry *) m->gui.ndesc.namee, m->app[m->activeApp].ndesc[i].name);
		gtk_text_buffer_set_text(buffer, m->app[m->activeApp].ndesc[i].desc, -1);
	}
	
	g_free(curloc);

	return;
}


void guiGetDir(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GtkWidget *dialog;
	
	dialog = gtk_file_chooser_dialog_new("Select directory", (gpointer) m->gui.main.window, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
	
	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
		if (m->dirname != NULL)
			g_free(m->dirname);
		
		m->dirname = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		m->flags |= GPND_MAIN_DIR_IS_SET;
	}

	guiUpdateMainButtonActivity(m);
	gtk_widget_destroy(dialog);

	return;
}


char *guiGetSourceFile(GPND_MAIN *m, const char *title, const char *file, const char *directory) {
	GtkWidget *dialog;
	char *sfile = NULL;
	
	dialog = gtk_file_chooser_dialog_new(title, (gpointer) m->gui.state.window, GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
	if (file != NULL)
		gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(dialog), file);
	
	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
		
		sfile = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		gtk_widget_destroy(dialog);
		return sfile;
	}
	
	gtk_widget_destroy(dialog);
	
	return NULL;
}


void guiSetGeneral(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GPND_GENERAL_VALIDATE_INPUT_STRUCT val;
	
	val.author = gtk_entry_get_text((GtkEntry *) m->gui.general.authore);
	val.http = gtk_entry_get_text((GtkEntry *) m->gui.general.httpe);
	val.mail = gtk_entry_get_text((GtkEntry *) m->gui.general.maile);
	val.icon = gtk_entry_get_text((GtkEntry *) m->gui.general.icone);
	
	val.version[0] = gtk_spin_button_get_value_as_int((GtkSpinButton *) m->gui.general.majore);
	val.version[1] = gtk_spin_button_get_value_as_int((GtkSpinButton *) m->gui.general.minore);
	val.version[2] = gtk_spin_button_get_value_as_int((GtkSpinButton *) m->gui.general.releasee);
	val.version[3] = gtk_spin_button_get_value_as_int((GtkSpinButton *) m->gui.general.builde);

	if (generalValidate(m, &val) == -1)
		return;

	if (generalSet(m, &val) == -1)
		return;

	guiWindowKill(widget, m);

	return;
}


void guiSetRuntime(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	GPND_RUNTIME_VALIDATE_INPUT_STRUCT val;

	val.uid = gtk_entry_get_text((GtkEntry *) m->gui.runtime.uide);
	val.appdata = gtk_entry_get_text((GtkEntry *) m->gui.runtime.appdatae);
	val.startdir = gtk_entry_get_text((GtkEntry *) m->gui.runtime.startdire);
	val.execfile = gtk_entry_get_text((GtkEntry *) m->gui.runtime.execfilee);
	val.args = gtk_entry_get_text((GtkEntry *) m->gui.runtime.argse);

	val.cpufreq = gtk_combo_box_get_active((GtkComboBox *) m->gui.runtime.cpufreqe);
	val.x11 = gtk_combo_box_get_active((GtkComboBox *) m->gui.runtime.x11e);
	val.allowMultitasking = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(m->gui.runtime.allowMultitaskinge));
	val.standalone = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(m->gui.runtime.standalonee));

	if (runtimeValidate(m, &val) == -1) {
		return;
	}

	if (runtimeSet(m, &val) == -1) {
		return;
	}

	guiWindowKill(widget, m);

	return;
}


void guiGetGeneralIcon(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	char *icon;
	
	icon = guiGetSourceFile(m, "Select icon image", NULL, NULL);
	if (icon != NULL) {
		gtk_entry_set_text((GtkEntry *) m->gui.general.icone, icon);
		g_free(icon);
	}

	return;
}


void guiGetRuntimeExec(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	char *exec;
	
	exec = guiGetSourceFile(m, "Select application binary", NULL, NULL);
	if (exec != NULL) {
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.execfilee, exec);
		g_free(exec);
	}

	return;
}


void guiWindowKill(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m = (GPND_MAIN *) data;
	
	g_signal_handler_disconnect(m->gui.state.window, m->gui.state.childKillID);
	
	gtk_widget_destroy(m->gui.state.window);
	m->gui.state.flags ^= GPND_GUI_CHILD_IS_OPEN;
	m->gui.state.window = m->gui.main.window;
	guiUpdateMainButtonActivity(m);

	return;
}


void guiShowErrorMessage(GPND_MAIN *m, char *message) {
	GtkWidget *dialog;
	GtkWindow *window;

	window = (GtkWindow *) m->gui.state.window;
	
	dialog = gtk_message_dialog_new(window,
		GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		(char *) message);
	gtk_window_set_title(GTK_WINDOW(dialog), GPND_MSG_FATAL_ERROR);
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
	
	return;
}


void guiMakeAppGeneralDiag(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m;
	m = (GPND_MAIN *) data;

	if (m->gui.state.flags & GPND_GUI_CHILD_IS_OPEN)
		return;
	else {
		m->gui.state.flags |= GPND_GUI_CHILD_IS_OPEN; 
		guiUpdateMainButtonActivity(m);
	}
	
	m->gui.state.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(m->gui.state.window), 200, 100);
	gtk_window_set_title(GTK_WINDOW(m->gui.state.window), "gPND maker - General information");
	gtk_container_set_border_width(GTK_CONTAINER(m->gui.state.window), 5);
	
	m->gui.general.table = gtk_table_new(6, 6, FALSE);
	gtk_container_add(GTK_CONTAINER(m->gui.state.window), m->gui.general.table);
	
	m->gui.general.authorl = gtk_label_new("Author");
	m->gui.general.httpl = gtk_label_new("Homepage");
	m->gui.general.maill = gtk_label_new("E-mail");
	m->gui.general.iconl = gtk_label_new("Menu icon file\n(max 32×32)");
	m->gui.general.versionl = gtk_label_new("Version");

	m->gui.general.majorl = gtk_label_new("Major");
	m->gui.general.minorl = gtk_label_new("Minor");
	m->gui.general.releasel = gtk_label_new("Release");
	m->gui.general.buildl = gtk_label_new("Build");

	m->gui.general.canbtn = gtk_button_new_with_label("Cancel");
	gtk_widget_set_size_request(m->gui.general.canbtn, 80, 30 );
	m->gui.general.okbtn = gtk_button_new_with_label("OK");
	gtk_widget_set_size_request(m->gui.general.okbtn, 80, 30 );
	m->gui.general.browsebtn = gtk_button_new_with_label("Browse");
	gtk_widget_set_size_request(m->gui.general.browsebtn, 80, 30 );

	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.authorl, 0, 1, 0, 1, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.httpl, 0, 1, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.maill, 0, 1, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.versionl, 0, 1, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.majorl, 1, 2, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.minorl, 2, 3, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.releasel, 3, 4, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.buildl, 4, 5, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.iconl, 0, 1, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.canbtn, 0, 1, 6, 7, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);

	m->gui.general.authore = gtk_entry_new();
	
	if (m->app[m->activeApp].author != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.general.authore, m->app[m->activeApp].author);
	m->gui.general.httpe = gtk_entry_new();
	
	if (m->app[m->activeApp].http != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.general.httpe, m->app[m->activeApp].http);
	m->gui.general.maile = gtk_entry_new();
	
	if (m->app[m->activeApp].mail != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.general.maile, m->app[m->activeApp].mail);
	m->gui.general.icone = gtk_entry_new();

	if (m->app[m->activeApp].icon != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.general.icone, m->app[m->activeApp].icon);

	m->gui.general.majore = gtk_spin_button_new_with_range(0.0, 255.0, 1.0);
	m->gui.general.minore = gtk_spin_button_new_with_range(0.0, 255.0, 1.0);
	m->gui.general.releasee = gtk_spin_button_new_with_range(0.0, 255.0, 1.0);
	m->gui.general.builde = gtk_spin_button_new_with_range(0.0, 255.0, 1.0);

	gtk_spin_button_set_digits((GtkSpinButton *) m->gui.general.majore, 0);
	gtk_spin_button_set_digits((GtkSpinButton *) m->gui.general.minore, 0);
	gtk_spin_button_set_digits((GtkSpinButton *) m->gui.general.releasee, 0);
	gtk_spin_button_set_digits((GtkSpinButton *) m->gui.general.builde, 0);

	gtk_spin_button_set_increments((GtkSpinButton *) m->gui.general.majore, 1.0, 1.0);
	gtk_spin_button_set_increments((GtkSpinButton *) m->gui.general.minore, 1.0, 1.0);
	gtk_spin_button_set_increments((GtkSpinButton *) m->gui.general.releasee, 1.0, 1.0);
	gtk_spin_button_set_increments((GtkSpinButton *) m->gui.general.builde, 1.0, 1.0);

	gtk_spin_button_set_snap_to_ticks((GtkSpinButton *) m->gui.general.majore, TRUE);
	gtk_spin_button_set_snap_to_ticks((GtkSpinButton *) m->gui.general.minore, TRUE);
	gtk_spin_button_set_snap_to_ticks((GtkSpinButton *) m->gui.general.releasee, TRUE);
	gtk_spin_button_set_snap_to_ticks((GtkSpinButton *) m->gui.general.builde, TRUE);

	gtk_spin_button_set_value((GtkSpinButton *) m->gui.general.majore, m->app[m->activeApp].version[0]);
	gtk_spin_button_set_value((GtkSpinButton *) m->gui.general.minore, m->app[m->activeApp].version[1]);
	gtk_spin_button_set_value((GtkSpinButton *) m->gui.general.releasee, m->app[m->activeApp].version[2]);
	gtk_spin_button_set_value((GtkSpinButton *) m->gui.general.builde, m->app[m->activeApp].version[3]);


	
	
	
	
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.authore, 1, 7, 0, 1, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.httpe, 1, 7, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.maile, 1, 7, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.majore, 1, 2, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.minore, 2, 3, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.releasee, 3, 4, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.builde, 4, 5, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.icone, 1, 4, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.browsebtn, 4, 7, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 0, 5);
	gtk_table_attach(GTK_TABLE(m->gui.general.table), m->gui.general.okbtn, 1, 7, 6, 7, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	

	gtk_widget_show_all(m->gui.state.window);

	g_signal_connect(G_OBJECT(m->gui.general.browsebtn), "clicked", G_CALLBACK(guiGetGeneralIcon), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.general.okbtn), "clicked", G_CALLBACK(guiSetGeneral), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.general.canbtn), "clicked", G_CALLBACK(guiWindowKill), (gpointer) m);
	m->gui.state.childKillID = g_signal_connect(m->gui.state.window, "destroy", G_CALLBACK(guiWindowKill), (gpointer) m);
	
	return;
}


void guiMakeRuntimeDiag(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m;
	m = (GPND_MAIN *) data;
	
	
	if (m->flags & 0x1)
		return;
	else {
		m->gui.state.flags |= 0x1; 
		guiUpdateMainButtonActivity(m);
	}
	
	m->gui.runtime.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(m->gui.runtime.window), 200, 100);
	gtk_window_set_title(GTK_WINDOW(m->gui.runtime.window), "gPND maker - Runtime settings");
	gtk_container_set_border_width(GTK_CONTAINER(m->gui.runtime.window), 5);
	
	m->gui.runtime.table = gtk_table_new(10, 3, FALSE);
	gtk_container_add(GTK_CONTAINER(m->gui.runtime.window), m->gui.runtime.table);
	
	m->gui.runtime.uidl = gtk_label_new("Unique ID");
	m->gui.runtime.appdatal = gtk_label_new("Appdata directory");
	m->gui.runtime.startdirl = gtk_label_new("Starting directory");
	m->gui.runtime.x11l = gtk_label_new("x11 mode");
	m->gui.runtime.execfilel = gtk_label_new("Application binary");
	m->gui.runtime.argsl = gtk_label_new("Arguments");
	m->gui.runtime.cpufreql = gtk_label_new("CPU frequency");
	m->gui.runtime.allowMultitaskingl = gtk_label_new("Allow multitasking");
	m->gui.runtime.standalonel = gtk_label_new("Requires inputfile");

	m->gui.runtime.browsebtn = gtk_button_new_with_label("Browse");
	gtk_widget_set_size_request(m->gui.runtime.browsebtn, 80, 30 );
	m->gui.runtime.canbtn = gtk_button_new_with_label("Cancel");
	gtk_widget_set_size_request(m->gui.runtime.canbtn, 80, 30 );
	m->gui.runtime.okbtn = gtk_button_new_with_label("OK");
	gtk_widget_set_size_request(m->gui.runtime.okbtn, 80, 30 );
	
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.uidl, 0, 1, 0, 1, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.appdatal, 0, 1, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.startdirl, 0, 1, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.x11l, 0, 1, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.execfilel, 0, 1, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.argsl, 0, 1, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.cpufreql, 0, 1, 6, 7, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.allowMultitaskingl, 0, 1, 7, 8, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.standalonel, 0, 1, 8, 9, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.canbtn, 0, 1, 9, 10, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	
	
	m->gui.runtime.uide = gtk_entry_new();
	if (m->app[m->activeApp].uid != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.uide, m->app[m->activeApp].uid);
	
	m->gui.runtime.appdatae = gtk_entry_new();
	if (m->app[m->activeApp].appdata != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.appdatae, m->app[m->activeApp].appdata);
	
	m->gui.runtime.startdire = gtk_entry_new();
	if (m->app[m->activeApp].startdir != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.startdire, m->app[m->activeApp].startdir);
	
	m->gui.runtime.execfilee = gtk_entry_new();
	if (m->app[m->activeApp].execfile != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.execfilee, m->app[m->activeApp].execfile);
	
	m->gui.runtime.argse = gtk_entry_new();
	if (m->app[m->activeApp].args != NULL)
		gtk_entry_set_text((GtkEntry *) m->gui.runtime.argse, m->app[m->activeApp].args);
	
	
	m->gui.runtime.x11e = gtk_combo_box_new_text();
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.x11e), "Required");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.x11e), "No X11");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.x11e), "Don\'t care");

	gtk_combo_box_set_active((GtkComboBox *) m->gui.runtime.x11e, m->app[m->activeApp].x11);
	
	m->gui.runtime.cpufreqe = gtk_combo_box_new_text();
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "No change");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "200");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "300");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "400");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "500");
	gtk_combo_box_append_text(GTK_COMBO_BOX(m->gui.runtime.cpufreqe), "600");

	gtk_combo_box_set_active((GtkComboBox *) m->gui.runtime.cpufreqe, m->app[m->activeApp].cpufreq);
	
	m->gui.runtime.allowMultitaskinge = gtk_check_button_new_with_label("");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->gui.runtime.allowMultitaskinge), m->app[m->activeApp].allowMultitasking);
	
	m->gui.runtime.standalonee = gtk_check_button_new_with_label("");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->gui.runtime.standalonee), m->app[m->activeApp].standalone);
	
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.uide, 1, 3, 0, 1, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.appdatae, 1, 3, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.startdire, 1, 3, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.x11e, 1, 3, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.execfilee, 1, 2, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.browsebtn, 2, 3, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.argse, 1, 3, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.cpufreqe, 1, 3, 6, 7, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.allowMultitaskinge, 1, 3, 7, 8, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.standalonee, 1, 3, 8, 9, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.runtime.table), m->gui.runtime.okbtn, 1, 3, 9,10, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);

	m->gui.state.window = m->gui.runtime.window;

	g_signal_connect(G_OBJECT(m->gui.runtime.browsebtn), "clicked", G_CALLBACK(guiGetRuntimeExec), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.runtime.okbtn), "clicked", G_CALLBACK(guiSetRuntime), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.runtime.canbtn), "clicked", G_CALLBACK(guiWindowKill), (gpointer) m);
	m->gui.state.childKillID = g_signal_connect(m->gui.state.window, "destroy", G_CALLBACK(guiWindowKill), (gpointer) m);

	gtk_widget_show_all(m->gui.state.window);
	
	
	return;
}


void guiMakeNameDescDiag(GtkWidget *widget, gpointer data) {
	GPND_MAIN *m;
	m = (GPND_MAIN *) data;
	GtkTreeSelection *selection;
	int i;
	
	if (m->flags & GPND_GUI_CHILD_IS_OPEN)
		return;
	else {
		m->gui.state.flags |= GPND_GUI_CHILD_IS_OPEN; 
		guiUpdateMainButtonActivity(m);
	}
	
	m->gui.ndesc.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(m->gui.ndesc.window), 400, 300);
	gtk_window_set_title(GTK_WINDOW(m->gui.ndesc.window), "gPND maker - Name and description");
	gtk_container_set_border_width(GTK_CONTAINER(m->gui.ndesc.window), 5);

	m->gui.ndesc.vbox = gtk_vbox_new(FALSE, 5);
	m->gui.ndesc.btnbox = gtk_hbox_new(FALSE, 5);
	m->gui.ndesc.table = gtk_table_new(6, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.window), m->gui.ndesc.vbox);
	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.vbox), m->gui.ndesc.table);
	m->gui.ndesc.descscroll = gtk_scrolled_window_new(NULL, NULL);
	m->gui.ndesc.listscroll = gtk_scrolled_window_new(NULL, NULL);
	
	m->gui.ndesc.langl = gtk_label_new("Locale");
	m->gui.ndesc.namel = gtk_label_new("Name of application");
	m->gui.ndesc.descl = gtk_label_new("Description");

	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(m->gui.ndesc.listscroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW(m->gui.ndesc.listscroll), GTK_SHADOW_ETCHED_IN);
	
	m->gui.ndesc.list = gtk_tree_view_new();
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(m->gui.ndesc.list), FALSE);
	guiInitListView(m, m->gui.ndesc.list);


	m->gui.ndesc.addbtn = gtk_button_new_with_label("Add");
	gtk_widget_set_size_request(m->gui.ndesc.addbtn, 80, 30 );
	m->gui.ndesc.modbtn = gtk_button_new_with_label("Modify");
	gtk_widget_set_size_request(m->gui.ndesc.modbtn, 80, 30 );
	m->gui.ndesc.delbtn = gtk_button_new_with_label("Delete");
	gtk_widget_set_size_request(m->gui.ndesc.delbtn, 80, 30 );
	m->gui.ndesc.okbtn = gtk_button_new_with_label("OK");
	gtk_widget_set_size_request(m->gui.ndesc.okbtn, 80, 30 );
	
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.langl, 0, 1, 0, 1, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.namel, 0, 1, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.descl, 0, 1, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);


	i = 0;
	do {
		if (m->app[m->activeApp].ndesc[i].flags & GPND_MAIN_ENTRYISVALID)
			guiAddToListView(m, m->gui.ndesc.list, m->app[m->activeApp].ndesc[i].lang);
		i++;
	} while (m->app[m->activeApp].ndesc[i - 1].flags & GPND_MAIN_THEREISNEXTENTRY);
	
	m->gui.ndesc.desce = gtk_text_view_new();
	gtk_text_view_set_wrap_mode((GtkTextView *) m->gui.ndesc.desce, GTK_WRAP_WORD);
	m->gui.ndesc.namee = gtk_entry_new();
	
	m->gui.ndesc.lange = gtk_entry_new();
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.ndesc.list));

	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.descscroll), m->gui.ndesc.desce);
	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.listscroll), m->gui.ndesc.list);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(m->gui.ndesc.descscroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW(m->gui.ndesc.descscroll), GTK_SHADOW_ETCHED_IN);
	
	
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.lange, 1, 2, 0, 1, 
		GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.namee, 1, 2, 1, 2, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.descscroll, 1, 2, 2, 3, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_EXPAND, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.btnbox, 0, 2, 3, 4, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.listscroll, 0, 2, 4, 5, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_EXPAND, 5, 5);
	gtk_table_attach(GTK_TABLE(m->gui.ndesc.table), m->gui.ndesc.okbtn, 0, 2, 5, 6, 
		GTK_FILL | GTK_SHRINK, GTK_FILL | GTK_SHRINK, 5, 5);
	


	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.btnbox), m->gui.ndesc.addbtn);
	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.btnbox), m->gui.ndesc.modbtn);
	gtk_container_add(GTK_CONTAINER(m->gui.ndesc.btnbox), m->gui.ndesc.delbtn);
	gtk_widget_set_size_request(m->gui.ndesc.addbtn, 80, 30 );
	gtk_widget_set_size_request(m->gui.ndesc.modbtn, 80, 30 );
	gtk_widget_set_size_request(m->gui.ndesc.delbtn, 80, 30 );


	m->gui.state.window = m->gui.ndesc.window;
	
	g_signal_connect(G_OBJECT(m->gui.ndesc.addbtn), "clicked", G_CALLBACK(guiAddLocale), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.ndesc.modbtn), "clicked", G_CALLBACK(guiModLocale), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.ndesc.delbtn), "clicked", G_CALLBACK(guiDelLocale), (gpointer) m);
	//g_signal_connect(G_OBJECT(m->gui.ndesc.okbtn), "clicked", G_CALLBACK(gpndGetNDesc), (gpointer) m);
	g_signal_connect(selection, "changed", G_CALLBACK(guiUpdateLocale), (gpointer) m);
	//g_signal_connect(G_OBJECT(m->gtkruntime.canbtn), "clicked", G_CALLBACK(gpndWindowKill), (gpointer) m);
	m->gui.state.childKillID = g_signal_connect(m->gui.state.window, "destroy", G_CALLBACK(guiWindowKill), (gpointer) m);

	gtk_widget_show_all(m->gui.state.window);
	
	
	return;
}


int guiMakeMainWindow(GPND_MAIN *m) {
	GtkTreeSelection *selection;
	
	m->gui.main.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(m->gui.main.window), 200, 100);
	gtk_window_set_title(GTK_WINDOW(m->gui.main.window), "gPND maker");
	gtk_container_set_border_width(GTK_CONTAINER(m->gui.main.window), 5);
	
	m->gui.main.vbox = gtk_vbox_new(FALSE, 5);
	m->gui.main.hbox = gtk_hbox_new(FALSE, 5);
	m->gui.main.addbox = gtk_hbox_new(FALSE, 5);
	m->gui.main.toolbox = gtk_hbox_new(FALSE, 5);
	m->gui.main.mainbox = gtk_vbox_new(FALSE, 5);

	m->gui.main.appscroll = gtk_scrolled_window_new(NULL, NULL);

	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(m->gui.main.appscroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW(m->gui.main.appscroll), GTK_SHADOW_ETCHED_IN);
	
	m->gui.main.applist = gtk_tree_view_new();
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(m->gui.main.applist), FALSE);


	gtk_container_add(GTK_CONTAINER(m->gui.main.window), m->gui.main.mainbox);
	gtk_container_add(GTK_CONTAINER(m->gui.main.mainbox), m->gui.main.addbox);
	gtk_container_add(GTK_CONTAINER(m->gui.main.mainbox), m->gui.main.toolbox);
	gtk_container_add(GTK_CONTAINER(m->gui.main.mainbox), m->gui.main.hbox);
	gtk_box_pack_start(GTK_BOX(m->gui.main.hbox), m->gui.main.appscroll, TRUE, TRUE, 5);
	gtk_container_add(GTK_CONTAINER(m->gui.main.appscroll), m->gui.main.applist);
	gtk_container_add(GTK_CONTAINER(m->gui.main.hbox), m->gui.main.vbox);
	guiInitListView(m, m->gui.main.applist);
	
	m->gui.main.seldir = gtk_button_new_with_label(GPND_BTN_SELDIR);
	m->gui.main.appinfo = gtk_button_new_with_label(GPND_BTN_GENINFO);
	m->gui.main.apprun = gtk_button_new_with_label("Runtime data");
	m->gui.main.appndesc = gtk_button_new_with_label("Name and description");
	m->gui.main.cat = gtk_button_new_with_label("Menu categories");
	m->gui.main.savepnd = gtk_button_new_with_label("Export to PND");

	m->gui.main.addApp = gtk_button_new_with_label("Add app");
	m->gui.main.modApp = gtk_button_new_with_label("Rename app");
	m->gui.main.delApp = gtk_button_new_with_label("Remove app");
	m->gui.main.appName = gtk_entry_new();

	gtk_box_pack_start(GTK_BOX(m->gui.main.toolbox), m->gui.main.appName, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.toolbox), m->gui.main.addApp, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.toolbox), m->gui.main.modApp, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.toolbox), m->gui.main.delApp, TRUE, TRUE, 0);

	gtk_box_pack_start(GTK_BOX(m->gui.main.addbox), m->gui.main.seldir, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.vbox), m->gui.main.appinfo, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.vbox), m->gui.main.apprun, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.vbox), m->gui.main.appndesc, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.vbox), m->gui.main.cat, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(m->gui.main.mainbox), m->gui.main.savepnd, TRUE, TRUE, 0);

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m->gui.main.applist));
	m->gui.state.window = m->gui.main.window;
	
	g_signal_connect(G_OBJECT(m->gui.main.seldir), "clicked", G_CALLBACK(guiGetDir), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.appinfo), "clicked", G_CALLBACK(guiMakeAppGeneralDiag), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.apprun), "clicked", G_CALLBACK(guiMakeRuntimeDiag), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.appndesc), "clicked", G_CALLBACK(guiMakeNameDescDiag), (gpointer) m);
	/*g_signal_connect(G_OBJECT(m->gui.main.cat), "clicked", G_CALLBACK(gpndMakeCatDiag), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.savepnd), "clicked", G_CALLBACK(gpndMakeSavePNDDiag), (gpointer) m);*/
	g_signal_connect(G_OBJECT(m->gui.main.addApp), "clicked", G_CALLBACK(guiAddApp), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.modApp), "clicked", G_CALLBACK(guiModApp), (gpointer) m);
	g_signal_connect(G_OBJECT(m->gui.main.delApp), "clicked", G_CALLBACK(guiDelApp), (gpointer) m);
	g_signal_connect(selection, "changed", G_CALLBACK(guiChangeAppList), (gpointer) m);
	g_signal_connect(m->gui.main.window, "destroy", G_CALLBACK(gtk_main_quit), NULL);
	

	guiUpdateMainButtonActivity(m);
	
	gtk_widget_show_all(m->gui.main.window);
	
	return 0;
}
