#ifndef _GTKGUI_H_
#define _GTKGUI_H_

#define	GPND_GUI_CHILD_IS_OPEN		0x1

#define	GPND_GUI_APPS_IS_ADDED		0x20000
#define	GPND_GUI_GENERAL_INFO_IS_SET	0x100
#define	GPND_GUI_RUNTIME_INFO_IS_SET	0x200
#define	GPND_GUI_NDESC_INFO_IS_SET	0x400





typedef struct {
	GtkWidget		*window;
	GtkWidget		*vbox;
	GtkWidget		*hbox;
	GtkWidget		*addbox;
	GtkWidget		*toolbox;
	GtkWidget		*mainbox;
	GtkWidget		*applist;
	GtkWidget		*appscroll;
	GtkWidget		*dget;

	GtkWidget		*addApp;
	GtkWidget		*modApp;
	GtkWidget		*delApp;
	GtkWidget		*appName;
	
	GtkWidget		*seldir;
	GtkWidget		*appinfo;
	GtkWidget		*apprun;
	GtkWidget		*appndesc;
	GtkWidget		*cat;
	GtkWidget		*savepnd;
} GPND_GUI_MAIN;

typedef struct {
	GtkWidget		*table;
	
	GtkWidget		*authorl;
	GtkWidget		*httpl;
	GtkWidget		*maill;
	GtkWidget		*versionl;
	GtkWidget		*majorl;
	GtkWidget		*minorl;
	GtkWidget		*releasel;
	GtkWidget		*buildl;
	GtkWidget		*iconl;
	GtkWidget		*descl;

	GtkWidget		*authore;
	GtkWidget		*httpe;
	GtkWidget		*maile;
	GtkWidget		*majore;
	GtkWidget		*minore;
	GtkWidget		*releasee;
	GtkWidget		*builde;
	GtkWidget		*icone;
	GtkWidget		*desce;

	GtkWidget		*browsebtn;
	GtkWidget		*okbtn;
	GtkWidget		*canbtn;
} GPND_GUI_GENERAL;

typedef struct {
	GtkWidget		*window;
	GtkWidget		*table;
	
	GtkWidget		*uidl;
	GtkWidget		*appdatal;
	GtkWidget		*startdirl;
	GtkWidget		*x11l;
	GtkWidget		*execfilel;
	GtkWidget		*argsl;
	GtkWidget		*cpufreql;
	GtkWidget		*allowMultitaskingl;
	GtkWidget		*standalonel;

	GtkWidget		*uide;
	GtkWidget		*appdatae;
	GtkWidget		*startdire;
	GtkWidget		*x11e;
	GtkWidget		*execfilee;
	GtkWidget		*argse;
	GtkWidget		*cpufreqe;
	GtkWidget		*allowMultitaskinge;
	GtkWidget		*standalonee;

	GtkWidget		*browsebtn;
	GtkWidget		*okbtn;
	GtkWidget		*canbtn;
} GPND_GUI_RUNTIME;

typedef struct {
	GtkWidget		*window;
	GtkWidget		*table;
	GtkWidget		*vbox;
	GtkWidget		*btnbox;
	GtkWidget		*descscroll;
	GtkWidget		*listscroll;
	
	GtkWidget		*langl;
	GtkWidget		*namel;
	GtkWidget		*descl;

	GtkWidget		*lange;
	GtkWidget		*namee;
	GtkWidget		*desce;

	GtkWidget		*list;

	GtkWidget		*addbtn;
	GtkWidget		*delbtn;
	GtkWidget		*modbtn;
	GtkWidget		*okbtn;
} GPND_GUI_NDESC;

typedef struct {
	GtkWidget		*window;
	int			flags;
	int			childKillID;
} GPND_GUI_STATE;

typedef struct {
	GPND_GUI_GENERAL	general;
	GPND_GUI_RUNTIME	runtime;
	GPND_GUI_NDESC		ndesc;
	GPND_GUI_MAIN		main;
	GPND_GUI_STATE		state;
} GPND_GUI;

#include "types.h"

int guiInit(GPND_MAIN *m, int *argc, char ***argv);
void guiUpdateMainButtonActivity(GPND_MAIN *m);
void guiDisableAllMainButtons(GPND_MAIN *m);
void guiAddToListView(GPND_MAIN *m, GtkWidget *list, const gchar *str);
void guiInitListView(GPND_MAIN *m, GtkWidget *list);
void guiAddApp(GtkWidget *widget, gpointer data);
void guiModApp(GtkWidget *widget, gpointer data);
void guiDelApp(GtkWidget *widget, gpointer data);
void guiChangeAppList(GtkWidget *widget, gpointer data);
void guiAddLocale(GtkWidget *widget, gpointer data);
void guiModLocale(GtkWidget *widget, gpointer data);
void guiDelLocale(GtkWidget *widget, gpointer data);
void guiUpdateLocale(GtkWidget *widget, gpointer data);
void guiGetDir(GtkWidget *widget, gpointer data);
char *guiGetSourceFile(GPND_MAIN *m, const char *title, const char *file, const char *directory);
void guiSetGeneral(GtkWidget *widget, gpointer data);
void guiSetRuntime(GtkWidget *widget, gpointer data);
void guiWindowKill(GtkWidget *widget, gpointer data);
void guiShowErrorMessage(GPND_MAIN *m, char *message);
int guiMakeMainWindow(GPND_MAIN *m);
void guiGetGeneralIcon(GtkWidget *widget, gpointer data);
void guiMakeAppGeneralDiag(GtkWidget *widget, gpointer data);
void guiMakeRuntimeDiag(GtkWidget *widget, gpointer data);
void guiMakeNameDescDiag(GtkWidget *widget, gpointer data);


#endif
